## golang-github-smallstep-cli 0.15.16+ds

=== Makefile ===
all: lint test build

ci: test build

.PHONY: all ci

#################################################
# Determine the type of `push` and `version`
#################################################

# If TRAVIS_TAG is set then we know this ref has been tagged.
ifdef TRAVIS_TAG
VERSION ?= $(TRAVIS_TAG)
NOT_RC  := $(shell echo $(VERSION) | grep -v -e -rc)
	ifeq ($(NOT_RC),)
PUSHTYPE := release-candidate
	else
PUSHTYPE := release
	endif
# GITHUB Actions
else ifdef GITHUB_REF
VERSION ?= $(shell echo $(GITHUB_REF) | sed 's/^refs\/tags\///')
NOT_RC  := $(shell echo $(VERSION) | grep -v -e -rc)
	ifeq ($(NOT_RC),)
PUSHTYPE := release-candidate
	else
PUSHTYPE := release
	endif
else
VERSION ?= $(shell [ -d .git ] && git describe --tags --always --dirty="-dev")
# If we are not in an active git dir then try reading the version from .VERSION.
# .VERSION contains a slug populated by `git archive`.
VERSION := $(or $(VERSION),$(shell ./.version.sh .VERSION))
	ifeq ($(TRAVIS_BRANCH),master)
PUSHTYPE := master
	else
PUSHTYPE := branch
	endif
endif

VERSION := $(shell echo $(VERSION) | sed 's/^v//')
DEB_VERSION := $(shell echo $(VERSION) | sed 's/-/~/')

ifdef V
$(info    TRAVIS_TAG is $(TRAVIS_TAG))
$(info    GITHUB_REF is $(GITHUB_REF))
$(info    VERSION is $(VERSION))
$(info    DEB_VERSION is $(DEB_VERSION))
$(info    PUSHTYPE is $(PUSHTYPE))
endif

include make/common.mk
include make/docker.mk

#########################################
# Debian
#########################################

changelog:
	$Q echo "step-cli ($(DEB_VERSION)) unstable; urgency=medium" > debian/changelog
	$Q echo >> debian/changelog
	$Q echo "  * See https://github.com/smallstep/cli/releases" >> debian/changelog
	$Q echo >> debian/changelog
	$Q echo " -- Smallstep Labs, Inc. <techadmin@smallstep.com>  $(shell date -uR)" >> debian/changelog

debian: changelog
	$Q set -e; mkdir -p $(RELEASE); \
	OUTPUT=../step-cli_*.deb; \
	rm -f $$OUTPUT; \
	dpkg-buildpackage -b -rfakeroot -us -uc && cp $$OUTPUT $(RELEASE)/

distclean: clean

.PHONY: changelog debian distclean

#################################################
# Build statically compiled step binary for various operating systems
#################################################

BINARY_OUTPUT=$(OUTPUT_ROOT)binary/
RELEASE=./.releases

define BUNDLE_MAKE
	# $(1) -- Go Operating System (e.g. linux, darwin, windows, etc.)
	# $(2) -- Go Architecture (e.g. amd64, arm, arm64, etc.)
	# $(3) -- Go ARM architectural family (e.g. 7, 8, etc.)
	# $(4) -- Parent directory for executables generated by 'make'.
	$(q) GOOS_OVERRIDE='GOOS=$(1) GOARCH=$(2) GOARM=$(3)' PREFIX=$(4) make $(4)bin/step
endef

binary-linux:
	$(call BUNDLE_MAKE,linux,amd64,,$(BINARY_OUTPUT)linux/)

binary-linux-arm64:
	$(call BUNDLE_MAKE,linux,arm64,,$(BINARY_OUTPUT)linux.arm64/)

binary-linux-armv7:
	$(call BUNDLE_MAKE,linux,arm,7,$(BINARY_OUTPUT)linux.armv7/)

binary-linux-mips:
	$(call BUNDLE_MAKE,linux,mips,,$(BINARY_OUTPUT)linux.mips/)

binary-darwin:
	$(call BUNDLE_MAKE,darwin,amd64,,$(BINARY_OUTPUT)darwin/)

binary-windows:
	$(call BUNDLE_MAKE,windows,amd64,,$(BINARY_OUTPUT)windows/)

define BUNDLE
    # $(1) -- Format output as .ZIP archive, rather than .tar.gzip (for older windows architecture)
	# $(2) -- Binary Output Dir Name
	# $(3) -- Step Platform Name
	# $(4) -- Step Binary Architecture
	# $(5) -- Step Binary Name (For Windows Comaptibility)
	$(q) ./make/bundle.sh $(1) "$(BINARY_OUTPUT)$(2)" "$(RELEASE)" "$(VERSION)" "$(3)" "$(4)" "$(5)"
endef

bundle-linux: binary-linux binary-linux-arm64 binary-linux-armv7 binary-linux-mips
	$(call BUNDLE,,linux,linux,amd64,step)
	$(call BUNDLE,,linux.arm64,linux,arm64,step)
	$(call BUNDLE,,linux.armv7,linux,armv7,step)
	$(call BUNDLE,,linux.mips,linux,mips,step)

bundle-darwin: binary-darwin
	$(call BUNDLE,,darwin,darwin,amd64,step)

bundle-windows: binary-windows
	$(call BUNDLE,,windows,windows,amd64,step.exe)
	$(call BUNDLE,--zip,windows,windows,amd64,step.exe)

.PHONY: binary-linux binary-darwin binary-windows bundle-linux bundle-darwin bundle-windows

#################################################
# Targets for creating step artifacts
#################################################

docker-artifacts: docker-$(PUSHTYPE)

.PHONY: docker-artifacts

=== debian/changelog ===
golang-github-smallstep-cli (0.15.16+ds-4) unstable; urgency=medium

  * Team upload.
  * [ee1dcee] Set Standards-Version to 4.6.2.
  * [2604899] Add golang-golang-x-net-dev to depends.

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Oct 2023 21:27:58 +0200

golang-github-smallstep-cli (0.15.16+ds-3) unstable; urgency=medium

  * Updating maintainer info
  * Updating Standards-Version

 -- Peymaneh <peymaneh@posteo.net>  Tue, 20 Dec 2022 15:50:53 +0100

golang-github-smallstep-cli (0.15.16+ds-2) unstable; urgency=medium

  * Team Upload.
  * Cherry-pick upstream patch to fix FTBFS (Closes: #997559)

 -- Nilesh Patra <nilesh@debian.org>  Tue, 26 Oct 2021 03:23:57 +0530

golang-github-smallstep-cli (0.15.16+ds-1) unstable; urgency=medium

  * Team Upload.
  [ Peymaneh Nejad ]
  * Testing migration
  * d/rules: disable verbosity
  * Exclude vendored blackfriday from source
  * New upstream version 0.15.16+ds

  [ Nilesh Patra ]
  * d/p/0003-Replace-references-to-vendored-blackfriday.patch: Use
    packaged blackfriday package instead of the vendored
    one, which has been repacked

 -- Nilesh Patra <nilesh@debian.org>  Wed, 25 Aug 2021 00:11:14 +0530

golang-github-smallstep-cli (0.15.16-3) unstable; urgency=medium

  * d/control: Add dependencies

 -- Peymaneh Nejad <p.nejad@posteo.de>  Sat, 10 Jul 2021 18:44:42 +0200

golang-github-smallstep-cli (0.15.16-2) unstable; urgency=medium

  * Team Upload.
  * d/copyright: Update copyright for crypto/pemutil/ssh.go

 -- Nilesh Patra <nilesh@debian.org>  Fri, 09 Jul 2021 18:07:30 +0530

golang-github-smallstep-cli (0.15.16-1) unstable; urgency=medium

  * Initial release (Closes: #989857)

 -- Peymaneh Nejad <p.nejad@posteo.de>  Fri, 09 Jul 2021 10:15:58 +0530

=== debian/control ===
Source: golang-github-smallstep-cli
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Peymaneh <peymaneh@posteo.net>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-chzyer-readline-dev,
               golang-github-manifoldco-promptui-dev,
               golang-github-mgutz-ansi-dev,
               golang-github-russross-blackfriday-v2-dev,
               golang-github-pkg-errors-dev,
               golang-github-smallstep-assert-dev,
               golang-github-stretchr-testify-dev,
               golang-github-urfave-cli-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-smallstep-cli
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-smallstep-cli.git
Homepage: https://github.com/smallstep/cli
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/smallstep/cli

Package: golang-github-smallstep-cli-dev
Architecture: all
Depends: golang-github-chzyer-readline-dev,
         golang-github-manifoldco-promptui-dev,
         golang-github-mgutz-ansi-dev,
         golang-github-russross-blackfriday-v2-dev,
         golang-github-pkg-errors-dev,
         golang-github-smallstep-assert-dev,
         golang-github-stretchr-testify-dev,
         golang-github-urfave-cli-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         ${misc:Depends}
Description: go library for working with x509 certificates
 This package ships the crypto/x509utils library of step-cli
 (https://github.com/smallstep/cli).

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE := 1
export DH_GOPKG := github.com/smallstep/cli

# This package is only needed for one library: crypto/x509util
# Exclude packages that are not needed to keep dependencies simple.
export DH_GOLANG_BUILDPKG := $(DH_GOPKG)/crypto/x509util
export DH_GOLANG_EXCLUDES := cmd/ \
			     crypto/kdf/ \
			     crypto/pemutil/testdata/ \
			     crypto/sshutil \
			     exec/ \
			     flags/ \
			     integration/ \
			     jose/ \
			     token/ \
		             utils/cautils/

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

=== debian/watch ===
version=4
opts="repack, \
      repacksuffix=+ds, \
      dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-smallstep-cli-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/smallstep/cli/tags .*/v?(\d\S*)\.tar\.gz debian
